#include <WiFi.h>
#include <WiFiUdp.h>
#include <OSCMessage.h> // for sending OSC messages
#include <ESPmDNS.h>
#include "Arduino.h"

#ifndef STASSID
#define STASSID "*******" //SSID wifi network
#define STAPSK  "*******" //Password Network
#endif


const char* ssid = STASSID;
const char* password = STAPSK;
const int sensorPin = 0; //pin 0 to read analog input
const int ledPin =  LED_BUILTIN;      // the number of the LED pin

unsigned long previousMillis;

// Variables Force FSR
int valueFSR; 
int SensorThreshold = 500; // Sensibility of the trigger
bool pressed = false;

//******** init OSC ****************************** 
String adresseOSC = "***/OSC commands address/***";
String phraseOSC;
const char* messageOSC;

WiFiUDP Udp;                           // A UDP instance to let us send and receive packets over UDP
const IPAddress destIp(2,0,0,145);     // IP address of the target device as light controller device
const unsigned int destPort = 6000;    // port of the target device where the ESP32 sends OSC to
const unsigned int localPort = 7000;   // local port to listen for UDP packets at the ESP32 (another device must send OSC messages to this port)

//******** fin OSC ****************************** 




//******** init program **********

void setup() {
  pinMode(sensorPin, INPUT);
  pinMode(LED_BUILTIN, OUTPUT);  
  
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
    //Serial.println("Connection Failed! Rebooting...");
    delay(5000);
    ESP.restart();

  }

  pinMode(ledPin, OUTPUT);

}

void loop() {

  valueFSR = analogRead(sensorPin);     //Read FSR State 

//****************** OSC Function ************************

// FSR pressed condition

  if (valueFSR>SensorThreshold && pressed==false) {
    pressed = true;
        phraseOSC = adresseOSC; 
        messageOSC = phraseOSC.c_str();  
  
        OSCMessage msgOut(messageOSC);
        msgOut.add("true"); 
        Udp.beginPacket(destIp, destPort);
        msgOut.send(Udp);
        digitalWrite(LED_BUILTIN, LOW);

        Udp.endPacket();
        msgOut.empty();
 
  }

// FSR released condition

  else if (valueFSR<=SensorThreshold && pressed==true){
    pressed = false;

        phraseOSC = adresseOSC; 
        messageOSC = phraseOSC.c_str();
  
        OSCMessage msgOut(messageOSC);
        msgOut.add("false"); 
        Udp.beginPacket(destIp, destPort);
        msgOut.send(Udp);
        digitalWrite(LED_BUILTIN, HIGH);

        Udp.endPacket();
        msgOut.empty();
 
    }
      


  delay(5);



}
